#!/bin/bash
#
# Copyright 2014 by Thomas Jampen
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.



is-binary-installed() {
	local BINARY="${1}"

	if [ ! -x ${BINARY} ]
	then
		echo "${BINARY} is not installed."
		return 1
	fi
}



urlencode() {
	local length="${#1}"

	for (( i = 0; i < length; i++ ))
	do
		local c="${1:i:1}"
		case $c in
			[a-zA-Z0-9.~_-])
				printf "$c"
				;;

			' ')
				printf +
				;;

			*)
				printf '%%%X' "'$c"
				;;
		esac
	done
}

get-best-sudo-program() {
	if [ -x /usr/bin/pkexec ]
	then
		echo "pkexec"
		return 0
	else
		echo "sudo"
		return 0
	fi
}
